#include "qt_serialize.hpp"
#include <iostream>

std::ostream & operator<<( std::ostream & os, const QSize & sz )
{
        if( ! os.good() ) return os;
        return os << sz.width()<<"x"<<sz.height();
}

std::istream & operator>>( std::istream & is, QSize & sz )
{
        if( ! is.good() ) return is;
        int w = -1, h = -1;
        is >> w;
        char foo;
        if( is.good() ) is >> foo; // "x"
        if( is.good() ) is >> h;
        //std::cerr << "istream>>QSize: w="<<w<<", h="<<h<<"\n";
        if( -1 != w && -1 != h )
        {
                sz.setWidth(w);
                sz.setHeight(h);
        }
        return is;
}

std::ostream & operator<<( std::ostream & os, const QPoint & pt )
{
        if( ! os.good() ) return os;
        return os << pt.x()<<","<<pt.y();
}

std::istream & operator>>( std::istream & is, QPoint & pt )
{
        if( ! is.good() ) return is;
        int x = -1, y = -1;
        is >> x;
        char foo;
        if( is.good() ) is >> foo; // ","
        if( is.good() ) is >> y;
        //std::cerr << "istream>>QPoint: x="<<x<<", y="<<y<<"\n";
        if( -1 != x && -1 != y )
        {
                pt.setX(x);
                pt.setY(y);
        }
        return is;
}

